// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "the_twilight_abyss/BaseItems/Items/BaseItem.h"
#include "TempCharacter.generated.h"

UCLASS()
class THE_TWILIGHT_ABYSS_API ATempCharacter : public ACharacter
{
	GENERATED_BODY()

	//Player inventory
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = Inventory, meta = (AllowPrivateAccess = "true"))
	class UInventoryComponent* Inventory; //Using the InventoryComponent class

public:
	// Sets default values for this character's properties
	ATempCharacter();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

	void ForwardInput(float Axis);
	void RightMoveInput(float Axis);

public:
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;
	
	void KeyPressed();
	
	UPROPERTY(EditAnyWhere)
	float TraceDistance = 200;
	
	void LineTraceLogic();

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category= "Health")
	float Health;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category= "Gold")
	int GoldBalance;

	//Using the item in the inventory
	UFUNCTION(BlueprintCallable, Category= "Items")
	void UseItem(class UBaseItem* Item); // Overriding the BaseItem Class
	
	UFUNCTION(BlueprintCallable, Category= "Items")
	void BuyItem(class UBaseItem* BuyItem);

	// UPROPERTY(EditAnywhere, Category= "Items")
	// UBaseItem ItemToBuy;
};
